# samples

In the context of Furnace, a sound sample (usually just referred to as a sample) is a string of numbers that hold sampled PCM audio.

In Furnace, these samples can be generated by importing a .wav (think of it as an higher quality MP3) file.

## supported systems

As of Furnace 0.5.5, the following sound chips have sample support:
 - NES/Ricoh 2A03 (PCM only, no DPCM, and only on channel 5)
 - Sega Genesis/YM2612 (channel 6 only; but only if there exists a `1701` effect that gets played on or before a trigger for a sample)
 - PC Engine/TurboGrafx 16/Huc6280 (same conditions as above)
 - Amiga/Paula (on all channels AND resamplable, but you need to make an instrument with the Amiga format and tie it to a sample first)
 - Arcade/SEGA PCM (same as above but you don't need to make an instrument for it and you have to use the `20xx` effect command to resample your samples)
 - Neo Geo/Neo Geo EXT-Ch2 (on the last 7 channels only and can be resampled the same way as above)
 - Seta/Allumer X1-010 (same as above, and both `1701` and `20xx` effect commands are affected on all 16 channels)

Furnace also has a feature where you can make an Amiga formarted instrument on the YM2612 and Huc6280 to resample a sample you have in the module.

# the sample editor

You can actually tweak your samples in Furnace's sample editor, which can be accessed by clicking on `window` (at the top of the screen) then clicking on `sample editor`.

In there, you can modify certain data pertaining to your sample, such as the:
 - volume of the sample (from 0% of the original to 200% of the original)
 - pitch of the sample (from 1/6 of the original sample pitch to 6x the original sample pitch)
 - and the sample rate of the sample (from 1KHz (1,000Hz) to 32KHz (32,000Hz)).

To apply the changes you made to a sample, just click the `apply` button at the bottom, near the preview button.

# tips
If you have a sample you wanna use that is about 44100 or anything over 32000Hz downsample the sample to 32000Hz so that the pitch of the sample in Furnace stays like the original wav. You can do this in Audacity by going to the Bottom Left of audacity (If you see "Project Rate (Hz)" you are there) and changing the project rate to 32000Hz and save the file to wav in Audacity using "File -> Export -> Export as WAV".
